Jump to content
Pelle

How to change a block with another block!?

Recommended Posts

Pelle

Hi All

 

Im sitting with at little quistion, because I have alot of dwg's with different blocks in them. I now need to change one specific block with another block. Since I have around 100 drawings where I have to change the block then I was hoping that there would be an easy way so I don't have to go in manually in each dwg. Can you help me or give me some hints on how to do this? o:)

 

FYI:

I can not change the old block in block editor because I still need it.

Share this post


Link to post
Share on other sites
Dadgad

Try using the BLOCKREPLACE command.

Share this post


Link to post
Share on other sites
BIGAL

Using VL lisp you can PUT a new block name against an existing block you would read stuff like scale rotation etc as well. Then you could script the 100 dwgs and just churn through very quickly.

 

script

open dwg1 (load "blkchange") close Y

open dwg2 etc

 

 ; this is just to show how it could be done
(setq blkobj (vlax-ename->vla-object(car (entsel "\nPick block"))))
; (setq blkoldname (vla-get-name blkobj)) ; just here to show GET method for block name for ssget
(setq newblk (getstring "\Enter name of new block")) ; note is case sensitive
; need ssget here all blocks
; need vlax-for here to go through all blocks
(vla-put-name blkobj newblk) ; updates block

Share this post


Link to post
Share on other sites
BIGAL

Version 2 like Dadgad just script it

 

open dwg1 -blockreplace oldblockname newblockname N close Y
open dwg2 -blockreplace oldblockname newblockname N close Y
open dwg3 -blockreplace oldblockname newblockname N close Y

Share this post


Link to post
Share on other sites
N3cr0Rav3

Hi, could someone help me with that lisp or send to me something other, i use a changeblock.lisp, program works excellent, but i need to change block with their base point, that can be possible?

 

(defun c:CHANGEBLOCK(/ ACTDOC COPOBJ ERRCOUNT EXTLST
       EXTSET FROMCEN LAYCOL MAXPT CURLAY
       MINPT OBJLAY OKCOUNT OLAYST
       SCLAY TOCEN TOOBJ VLAOBJ *ERROR*)
 (vl-load-com)
 (defun *ERROR*(msg)
   (if olaySt
     (vla-put-Lock objLay olaySt)
     ); end if
   (vla-EndUndoMark actDoc)
   (princ)
   ); end of *ERROR*
 (defun GetBoundingCenter(vlaObj / blPt trPt cnPt)
 (vla-GetBoundingBox vlaObj 'minPt 'maxPt)
     (setq blPt(vlax-safearray->list minPt)
      trPt(vlax-safearray->list maxPt)
      cnPt(vlax-3D-point
       (list
            (+(car blPt)(/(-(car trPt)(car blPt))2))
            (+(cadr blPt)(/(-(cadr trPt)(cadr blPt))2))
         0.0
           ); end list
     ); end vlax-3D-point
    ); end setq
 ); end of GetBoundingCenter
 (if(not(setq extSet(ssget "_I")))
   (progn
     (princ "\nSelect objects, need to replace ")
     (setq extSet(ssget))
     ); end progn
   ); end if
 (if(not extSet)
   (princ "\nDistination objects isn't selected!")
   ); end if
 (if
   (and
   extSet
   (setq toObj(entsel "\nSelect original object "))
   ); and and
   (progn
     (setq actDoc
       (vla-get-ActiveDocument
         (vlax-get-Acad-object))
      layCol
       (vla-get-Layers actDoc)
      extLst
       (mapcar 'vlax-ename->vla-object
                   (vl-remove-if 'listp
                    (mapcar 'cadr(ssnamex extSet))))
      vlaObj(vlax-ename->vla-object(car toObj))
      objLay(vla-Item layCol
            (vla-get-Layer vlaObj))
      olaySt(vla-get-Lock objLay)
      fromCen(GetBoundingCenter vlaObj)
      errCount 0
      okCount 0
      ); end setq
     (vla-StartUndoMark actDoc)
     (foreach obj extLst
  (setq toCen(GetBoundingCenter obj)
        scLay(vla-Item layCol
             (vla-get-Layer obj))
             );end setq
  (if(/= :vlax-true(vla-get-Lock scLay))
    (progn
    (setq curLay(vla-get-Layer obj))
    (vla-put-Lock objLay :vlax-false)
    (setq copObj(vla-copy vlaObj))
    (vla-Move copObj fromCen toCen)
    (vla-put-Layer copObj curLay)
    (vla-put-Lock objLay olaySt)
    (vla-Delete obj)
    (setq okCount(1+ okCount))
    ); end progn
    (setq errCount(1+ errCount))
    ); end if
  ); end foreach
     (princ
  (strcat "\n" (itoa okCount) " were changed. "
     (if(/= 0 errCount)
       (strcat (itoa errCount) " were on locked layer! ")
       ""
       ); end if
     ); end strcat
  ); end princ
     (vla-EndUndoMark actDoc)
     ); end progn
   (princ "\nSource object isn't selected! ")
   ); end if
 (princ)
 ); end of c:CHANGEBLOCK

Share this post


Link to post
Share on other sites

Create an account or sign in to comment

You need to be a member in order to leave a comment

Create an account

Sign up for a new account in our community. It's easy!

Register a new account

Sign in

Already have an account? Sign in here.

Sign In Now

×